/**
 * org.apache.flex.charts.BarChart
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.charts.BarChart');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.html.List');
goog.require('org.apache.flex.charts.core.IChart');



/**
 * @constructor
 * @extends {org.apache.flex.html.List}
 * @implements {org.apache.flex.charts.core.IChart}
 */
org.apache.flex.charts.BarChart = function() {
  org.apache.flex.charts.BarChart.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.BarChart, org.apache.flex.html.List);


/**
 * @private
 * @type {Array}
 */
org.apache.flex.charts.BarChart.prototype._series;


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.charts.BarChart.prototype.get_series = function() {
  return this._series;
};


/**
 * @expose
 * @param {Array} value
 */
org.apache.flex.charts.BarChart.prototype.set_series = function(value) {
  this._series = value;
  this.dispatchEvent(new org.apache.flex.events.Event("seriesChanged"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.BarChart.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'BarChart', qName: 'org.apache.flex.charts.BarChart'}], interfaces: [org.apache.flex.charts.core.IChart] };
