/**
 * org.apache.flex.charts.beads.ChartItemRendererFactory
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.charts.beads.ChartItemRendererFactory');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.charts.core.IChartItemRenderer');
goog.require('org.apache.flex.charts.core.IChartSeries');
goog.require('org.apache.flex.html.beads.IListView');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.core.IDataProviderItemRendererMapper');
goog.require('org.apache.flex.charts.core.IChart');
goog.require('org.apache.flex.core.ISelectionModel');
goog.require('org.apache.flex.core.IItemRendererParent');
goog.require('org.apache.flex.core.IItemRendererClassFactory');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.core.IDataProviderItemRendererMapper}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.ISelectionModel}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.selectionModel;


/**
 * @protected
 * @type {org.apache.flex.core.IItemRendererParent}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.dataGroup;


/**
 * @private
 * @type {Array}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype._seriesRenderers;


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.get_seriesRenderers = function() {
  return this._seriesRenderers;
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.set_strand = function(value) {
  this._strand = value;
  this.selectionModel = org.apache.flex.utils.Language.as(value.getBeadByType(org.apache.flex.core.ISelectionModel), org.apache.flex.core.ISelectionModel);
  var /** @type {org.apache.flex.html.beads.IListView} */ listView = org.apache.flex.utils.Language.as(value.getBeadByType(org.apache.flex.html.beads.IListView), org.apache.flex.html.beads.IListView);
  this.dataGroup = listView.get_dataGroup();
  var /** @type {Array} */ dp = org.apache.flex.utils.Language.as(this.selectionModel.get_dataProvider(), Array);
  if (!dp)
    return;
  this._seriesRenderers = new Array();
  this.dataGroup.removeAllElements();
  var /** @type {Array} */ series = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.charts.core.IChart, true).get_series();
  for (var /** @type {number} */ j = 0; j < dp.length; j++) {
    var /** @type {Array} */ renderers = new Array();
    for (var /** @type {number} */ i = 0; i < series.length; i++) {
      var /** @type {org.apache.flex.charts.core.IChartSeries} */ s = org.apache.flex.utils.Language.as(series[i], org.apache.flex.charts.core.IChartSeries);
      var /** @type {org.apache.flex.charts.core.IChartItemRenderer} */ k = org.apache.flex.utils.Language.as(s.get_itemRenderer().newInstance(), org.apache.flex.charts.core.IChartItemRenderer);
      k.set_xField(s.get_xField());
      k.set_yField(s.get_yField());
      k.set_fillColor(s.get_fillColor());
      k.set_data(dp[j]);
      k.set_index(j);
      renderers.push(k);
      this.dataGroup.addElement(k);
    }
    this._seriesRenderers.push(renderers);
  }
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("itemsCreated"));
};


/**
 * @expose
 * @return {org.apache.flex.core.IItemRendererClassFactory}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.get_itemRendererFactory = function() {
  return null;
};


/**
 * @expose
 * @param {org.apache.flex.core.IItemRendererClassFactory} value
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.set_itemRendererFactory = function(value) {
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.beads.ChartItemRendererFactory.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'ChartItemRendererFactory', qName: 'org.apache.flex.charts.beads.ChartItemRendererFactory'}], interfaces: [org.apache.flex.core.IBead, org.apache.flex.core.IDataProviderItemRendererMapper] };
