/**
 * org.apache.flex.charts.supportClasses.BoxItemRenderer
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.charts.supportClasses.BoxItemRenderer');

goog.require('org.apache.flex.html.supportClasses.DataItemRenderer');
goog.require('org.apache.flex.core.FilledRectangle');
goog.require('org.apache.flex.charts.core.IChartItemRenderer');



/**
 * @constructor
 * @extends {org.apache.flex.html.supportClasses.DataItemRenderer}
 * @implements {org.apache.flex.charts.core.IChartItemRenderer}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer = function() {
  org.apache.flex.charts.supportClasses.BoxItemRenderer.base(this, 'constructor');
};
goog.inherits(org.apache.flex.charts.supportClasses.BoxItemRenderer, org.apache.flex.html.supportClasses.DataItemRenderer);


/**
 * @private
 * @type {Object}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype._itemRendererParent;


/**
 * @expose
 * @return {Object}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.get_itemRendererParent = function() {
  return this._itemRendererParent;
};


/**
 * @expose
 * @param {Object} value
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_itemRendererParent = function(value) {
  this._itemRendererParent = value;
};


/**
 * @private
 * @type {org.apache.flex.core.FilledRectangle}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.filledRect;


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype._yField = "y";


/**
 * @expose
 * @return {string}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.get_yField = function() {
  return this._yField;
};


/**
 * @expose
 * @param {string} value
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_yField = function(value) {
  this._yField = value;
};


/**
 * @private
 * @type {string}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype._xField = "x";


/**
 * @expose
 * @return {string}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.get_xField = function() {
  return this._xField;
};


/**
 * @expose
 * @param {string} value
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_xField = function(value) {
  this._xField = value;
};


/**
 * @private
 * @type {number}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype._fillColor;


/**
 * @expose
 * @return {number}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.get_fillColor = function() {
  return this._fillColor;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_fillColor = function(value) {
  this._fillColor = value;
};


/**
 * @expose
 * @param {Object} value
 * @override
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_data = function(value) {
  org.apache.flex.charts.supportClasses.BoxItemRenderer.base(this, 'set_data', value);
  if (this.filledRect == null) {
    this.filledRect = new org.apache.flex.core.FilledRectangle();
    this.addElement(this.filledRect);
  }
};


/**
 * @expose
 * @param {number} value
 * @override
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_width = function(value) {
  org.apache.flex.charts.supportClasses.BoxItemRenderer.base(this, 'set_width', value);
  this.drawBar();
};


/**
 * @expose
 * @param {number} value
 * @override
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.set_height = function(value) {
  org.apache.flex.charts.supportClasses.BoxItemRenderer.base(this, 'set_height', value);
  this.drawBar();
};


/**
 * @protected
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.drawBar = function() {
  if (this.filledRect) {
    this.filledRect.set_fillColor(this.get_fillColor());
    this.filledRect.drawRect(0, 0, this.get_width(), this.get_height());
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.charts.supportClasses.BoxItemRenderer.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'BoxItemRenderer', qName: 'org.apache.flex.charts.supportClasses.BoxItemRenderer'}], interfaces: [org.apache.flex.charts.core.IChartItemRenderer] };
