/**
 * org.apache.flex.html.DateField
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.DateField');

goog.require('org.apache.flex.core.ValuesManager');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.core.IDateChooserModel');



/**
 * @constructor
 * @extends {org.apache.flex.core.UIBase}
 */
org.apache.flex.html.DateField = function() {
  org.apache.flex.html.DateField.base(this, 'constructor');
  this.set_className("DateField");
};
goog.inherits(org.apache.flex.html.DateField, org.apache.flex.core.UIBase);


/**
 * @expose
 * @override
 */
org.apache.flex.html.DateField.prototype.addedToParent = function() {
  org.apache.flex.html.DateField.base(this, 'addedToParent');
  var /** @type {*} */ klass = org.apache.flex.core.ValuesManager.get_valuesImpl().getValue(this, "iFormatBead");
  var /** @type {org.apache.flex.core.IBead} */ bead = org.apache.flex.utils.Language.as(new klass(), org.apache.flex.core.IBead);
  if (bead) {
    this.addBead(bead);
  }
};


/**
 * @expose
 * @return {org.apache.flex.html.Date}
 */
org.apache.flex.html.DateField.prototype.get_selectedDate = function() {
  return org.apache.flex.utils.Language.as(this.get_model(), org.apache.flex.core.IDateChooserModel, true).get_selectedDate();
};


/**
 * @expose
 * @param {Date} value
 */
org.apache.flex.html.DateField.prototype.set_selectedDate = function(value) {
  org.apache.flex.utils.Language.as(this.get_model(), org.apache.flex.core.IDateChooserModel, true).set_selectedDate(value);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.DateField.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateField', qName: 'org.apache.flex.html.DateField'}] };
