/**
 * org.apache.flex.html.accessories.DateFormatMMDDYYYYBead
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.accessories.DateFormatMMDDYYYYBead');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.EventDispatcher');
goog.require('org.apache.flex.core.IFormatBead');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IBead');
goog.require('org.apache.flex.core.IDateChooserModel');



/**
 * @constructor
 * @extends {org.apache.flex.events.EventDispatcher}
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.core.IFormatBead}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead = function() {
  org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.accessories.DateFormatMMDDYYYYBead, org.apache.flex.events.EventDispatcher);


/**
 * @private
 * @type {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype._propertyName;


/**
 * @private
 * @type {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype._eventName;


/**
 * @private
 * @type {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype._formattedResult;


/**
 * @expose
 * @return {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.get_propertyName = function() {
  if (this._propertyName == null) {
    return "selectedDate";
  }
  return this._propertyName;
};


/**
 * @expose
 * @param {string} value
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.set_propertyName = function(value) {
  this._propertyName = value;
};


/**
 * @expose
 * @return {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.get_eventName = function() {
  if (this._eventName == null) {
    return this._propertyName + "Changed";
  }
  return this._eventName;
};


/**
 * @expose
 * @param {string} value
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.set_eventName = function(value) {
  this._eventName = value;
};


/**
 * @expose
 * @return {string}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.get_formattedString = function() {
  return this._formattedResult;
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.set_strand = function(value) {
  this._strand = value;
  var /** @type {org.apache.flex.core.IDateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IDateChooserModel), org.apache.flex.core.IDateChooserModel);
  model.addEventListener("selectedDateChanged", goog.bind(this.handleTextChange, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.handleTextChange = function(event) {
  var /** @type {org.apache.flex.core.IDateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IDateChooserModel), org.apache.flex.core.IDateChooserModel);
  var /** @type {Date} */ d = model.get_selectedDate();
  var /** @type {string} */ month = String(d.getMonth() + 1);
  if (Number(month) < 10)
    month = "0" + month;
  var /** @type {string} */ date = String(d.getDate());
  if (Number(date) < 10)
    date = "0" + date;
  var /** @type {string} */ fmt = month + "/" + date + "/" + String(d.getFullYear());
  this._formattedResult = month + "/" + date + "/" + String(d.getFullYear());
  this.dispatchEvent(new org.apache.flex.events.Event("formatChanged"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.accessories.DateFormatMMDDYYYYBead.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateFormatMMDDYYYYBead', qName: 'org.apache.flex.html.accessories.DateFormatMMDDYYYYBead'}], interfaces: [org.apache.flex.core.IBead, org.apache.flex.core.IFormatBead] };
