/**
 * org.apache.flex.html.beads.DataItemRendererFactoryForColumnData
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.DataItemRendererFactoryForColumnData');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBead}
 * @implements {org.apache.flex.core.IDataProviderItemRendererMapper}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.IDataGridModel}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.selectionModel;


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.set_strand = function(value) {
  this._strand = value;
  this.selectionModel = org.apache.flex.utils.Language.as(value.getBeadByType(org.apache.flex.core.IDataGridModel), org.apache.flex.core.IDataGridModel);
  var /** @type {org.apache.flex.html.beads.IListView} */ listView = org.apache.flex.utils.Language.as(value.getBeadByType(org.apache.flex.html.beads.IListView), org.apache.flex.html.beads.IListView);
  this.dataGroup = listView.get_dataGroup();
  this.selectionModel.addEventListener("dataProviderChanged", goog.bind(this.dataProviderChangeHandler, this));
  if (!this.get_itemRendererFactory()) {
    this._itemRendererFactory = org.apache.flex.utils.Language.as(new org.apache.flex.core.ValuesManager.get_valuesImpl().getValue(this._strand, "iItemRendererClassFactory")(), org.apache.flex.core.IItemRendererClassFactory);
    this._strand.addBead(this._itemRendererFactory);
  }
  this.dataProviderChangeHandler(null);
};


/**
 * @private
 * @type {org.apache.flex.core.IItemRendererClassFactory}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype._itemRendererFactory;


/**
 * @expose
 * @return {org.apache.flex.core.IItemRendererClassFactory}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.get_itemRendererFactory = function() {
  return this._itemRendererFactory;
};


/**
 * @expose
 * @param {org.apache.flex.core.IItemRendererClassFactory} value
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.set_itemRendererFactory = function(value) {
  this._itemRendererFactory = value;
};


/**
 * @protected
 * @type {org.apache.flex.core.IItemRendererParent}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.dataGroup;


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.dataProviderChangeHandler = function(event) {
  var /** @type {Array} */ dp = org.apache.flex.utils.Language.as(this.selectionModel.get_dataProvider(), Array);
  if (!dp)
    return;
  this.dataGroup.removeAllElements();
  var /** @type {org.apache.flex.html.beads.DataGridColumnView} */ view = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IBeadView), org.apache.flex.html.beads.DataGridColumnView);
  if (view == null)
    return;
  var /** @type {number} */ n = dp.length;
  for (var /** @type {number} */ i = 0; i < n; i++) {
    var /** @type {org.apache.flex.html.supportClasses.DataItemRenderer} */ tf = org.apache.flex.utils.Language.as(this.get_itemRendererFactory().createItemRenderer(this.dataGroup), org.apache.flex.html.supportClasses.DataItemRenderer);
    tf.set_index(i);
    tf.set_labelField(view.get_column().get_dataField());
    this.dataGroup.addElement(tf);
    tf.set_data(dp[i]);
  }
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("itemsCreated"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.DataItemRendererFactoryForColumnData.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DataItemRendererFactoryForColumnData', qName: 'org.apache.flex.html.beads.DataItemRendererFactoryForColumnData'}], interfaces: [org.apache.flex.core.IBead, org.apache.flex.core.IDataProviderItemRendererMapper] };
