/**
 * org.apache.flex.html.beads.DateChooserView
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.DateChooserView');

goog.require('org.apache.flex.html.beads.models.DateChooserModel');
goog.require('org.apache.flex.html.Container');
goog.require('org.apache.flex.core.ValuesManager');
goog.require('org.apache.flex.html.TextButton');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.html.supportClasses.DateChooserButton');
goog.require('org.apache.flex.core.BeadViewBase');
goog.require('org.apache.flex.html.beads.layouts.TileLayout');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IBeadView');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IBeadModel');



/**
 * @constructor
 * @extends {org.apache.flex.core.BeadViewBase}
 * @implements {org.apache.flex.core.IBeadView}
 */
org.apache.flex.html.beads.DateChooserView = function() {
  org.apache.flex.html.beads.DateChooserView.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.beads.DateChooserView, org.apache.flex.core.BeadViewBase);


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 * @override
 */
org.apache.flex.html.beads.DateChooserView.prototype.set_strand = function(value) {
  org.apache.flex.html.beads.DateChooserView.base(this, 'set_strand', value);
  this.model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IBeadModel), org.apache.flex.html.beads.models.DateChooserModel);
  if (this.model == null) {
    this.model = org.apache.flex.utils.Language.as(new org.apache.flex.core.ValuesManager.get_valuesImpl().getValue(this._strand, "iBeadModel")(), org.apache.flex.html.beads.models.DateChooserModel);
  }
  this.model.addEventListener("displayedMonthChanged", goog.bind(this.handleModelChange, this));
  this.model.addEventListener("displayedYearChanged", goog.bind(this.handleModelChange, this));
  this.createChildren();
};


/**
 * @private
 * @type {org.apache.flex.html.TextButton}
 */
org.apache.flex.html.beads.DateChooserView.prototype._prevMonthButton;


/**
 * @private
 * @type {org.apache.flex.html.TextButton}
 */
org.apache.flex.html.beads.DateChooserView.prototype._nextMonthButton;


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.DateChooserView.prototype._dayButtons;


/**
 * @private
 * @type {org.apache.flex.html.TextButton}
 */
org.apache.flex.html.beads.DateChooserView.prototype.monthLabel;


/**
 * @private
 * @type {org.apache.flex.html.Container}
 */
org.apache.flex.html.beads.DateChooserView.prototype.dayContainer;


/**
 * @private
 * @type {org.apache.flex.html.beads.models.DateChooserModel}
 */
org.apache.flex.html.beads.DateChooserView.prototype.model;


/**
 * @expose
 * @return {org.apache.flex.html.beads.TextButton}
 */
org.apache.flex.html.beads.DateChooserView.prototype.get_prevMonthButton = function() {
  return this._prevMonthButton;
};


/**
 * @expose
 * @return {org.apache.flex.html.beads.TextButton}
 */
org.apache.flex.html.beads.DateChooserView.prototype.get_nextMonthButton = function() {
  return this._nextMonthButton;
};


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.html.beads.DateChooserView.prototype.get_dayButtons = function() {
  return this._dayButtons;
};


/**
 * @private
 */
org.apache.flex.html.beads.DateChooserView.prototype.createChildren = function() {
  this._prevMonthButton = new org.apache.flex.html.TextButton();
  this._prevMonthButton.set_width(40);
  this._prevMonthButton.set_height(20);
  this._prevMonthButton.set_x(0);
  this._prevMonthButton.set_y(0);
  this._prevMonthButton.set_text("<");
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).addElement(this._prevMonthButton);
  this._nextMonthButton = new org.apache.flex.html.TextButton();
  this._nextMonthButton.set_width(40);
  this._nextMonthButton.set_height(20);
  this._nextMonthButton.set_x(org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width() - this._nextMonthButton.get_width());
  this._nextMonthButton.set_y(0);
  this._nextMonthButton.set_text(">");
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).addElement(this._nextMonthButton);
  this.monthLabel = new org.apache.flex.html.TextButton();
  this.monthLabel.set_text("Month Here");
  this.monthLabel.set_width(100);
  this.monthLabel.set_height(20);
  this.monthLabel.set_x((org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width() - this.monthLabel.get_width()) / 2);
  this.monthLabel.set_y(0);
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).addElement(this.monthLabel);
  this.dayContainer = new org.apache.flex.html.Container();
  var /** @type {org.apache.flex.html.beads.layouts.TileLayout} */ tileLayout = new org.apache.flex.html.beads.layouts.TileLayout();
  this.dayContainer.addBead(tileLayout);
  tileLayout.set_numColumns(7);
  this.dayContainer.set_x(0);
  this.dayContainer.set_y(this.monthLabel.get_y() + this.monthLabel.get_height() + 5);
  var /** @type {number} */ sw = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width();
  var /** @type {number} */ sh = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_height();
  org.apache.flex.utils.Language.trace("Strand's width x height is " + sw + " x " + sh);
  this.dayContainer.set_width(sw);
  this.dayContainer.set_height(sh - (this.monthLabel.get_height() + 5));
  for (var /** @type {number} */ i = 0; i < 7; i++) {
    var /** @type {org.apache.flex.html.supportClasses.DateChooserButton} */ dayName = new org.apache.flex.html.supportClasses.DateChooserButton();
    dayName.set_text(this.model.get_dayNames()[i]);
    dayName.set_dayOfMonth(0);
    this.dayContainer.addElement(dayName);
  }
  this._dayButtons = new Array();
  for (i = 0; i < 42; i++) {
    var /** @type {org.apache.flex.html.supportClasses.DateChooserButton} */ date = new org.apache.flex.html.supportClasses.DateChooserButton();
    date.set_text(String(i + 1));
    this.dayContainer.addElement(date);
    this.get_dayButtons().push(date);
  }
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).addElement(this.dayContainer);
  org.apache.flex.utils.Language.as(this.dayContainer, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("itemsCreated"));
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("layoutNeeded"));
  org.apache.flex.utils.Language.as(this.dayContainer, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("layoutNeeded"));
  this.updateCalendar();
};


/**
 * @private
 */
org.apache.flex.html.beads.DateChooserView.prototype.updateCalendar = function() {
  this.monthLabel.set_text(this.model.get_monthNames()[this.model.get_displayedMonth()] + " " + String(this.model.get_displayedYear()));
  var /** @type {Date} */ firstDay = new Date(this.model.get_displayedYear(), this.model.get_displayedMonth(), 1);
  for (var /** @type {number} */ i = 0; i < firstDay.getDay(); i++) {
    var /** @type {org.apache.flex.html.supportClasses.DateChooserButton} */ dateButton = org.apache.flex.utils.Language.as(this.get_dayButtons()[i], org.apache.flex.html.supportClasses.DateChooserButton);
    dateButton.set_dayOfMonth(-1);
    dateButton.set_text("");
  }
  var /** @type {number} */ dayNumber = 1;
  var /** @type {number} */ numDays = this.numberOfDaysInMonth(this.model.get_displayedMonth(), this.model.get_displayedYear());
  for (; i < this.get_dayButtons().length && dayNumber <= numDays; i++) {
    dateButton = org.apache.flex.utils.Language.as(this.get_dayButtons()[i], org.apache.flex.html.supportClasses.DateChooserButton);
    dateButton.set_dayOfMonth(dayNumber);
    dateButton.set_text(String(dayNumber++));
  }
  for (; i < this.get_dayButtons().length; i++) {
    dateButton = org.apache.flex.utils.Language.as(this.get_dayButtons()[i], org.apache.flex.html.supportClasses.DateChooserButton);
    dateButton.set_dayOfMonth(-1);
    dateButton.set_text("");
  }
};


/**
 * @private
 * @param {number} month
 * @param {number} year
 * @return {number}
 */
org.apache.flex.html.beads.DateChooserView.prototype.numberOfDaysInMonth = function(month, year) {
  var /** @type {number} */ n;
  if (month == 1) {
    if (((year % 4 == 0) && (year % 100 != 0)) || (year % 400 == 0))
      n = 29;
    else
      n = 28;
  }
  else if (month == 3 || month == 5 || month == 8 || month == 10)
    n = 30;
  else
    n = 31;
  return n;
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.DateChooserView.prototype.handleModelChange = function(event) {
  this.updateCalendar();
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.DateChooserView.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateChooserView', qName: 'org.apache.flex.html.beads.DateChooserView'}], interfaces: [org.apache.flex.core.IBeadView] };
