/**
 * org.apache.flex.html.beads.FormatableLabelView
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.FormatableLabelView');

goog.require('org.apache.flex.html.beads.TextFieldView');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IFormatBead');
goog.require('org.apache.flex.core.IStrand');



/**
 * @constructor
 * @extends {org.apache.flex.html.beads.TextFieldView}
 */
org.apache.flex.html.beads.FormatableLabelView = function() {
  org.apache.flex.html.beads.FormatableLabelView.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.beads.FormatableLabelView, org.apache.flex.html.beads.TextFieldView);


/**
 * @private
 * @type {org.apache.flex.core.IFormatBead}
 */
org.apache.flex.html.beads.FormatableLabelView.prototype._formatter;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 * @override
 */
org.apache.flex.html.beads.FormatableLabelView.prototype.set_strand = function(value) {
  org.apache.flex.html.beads.FormatableLabelView.base(this, 'set_strand', value);
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("beadsAdded", goog.bind(this.handleBeadsAdded, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.FormatableLabelView.prototype.handleBeadsAdded = function(event) {
  this._formatter = org.apache.flex.utils.Language.as(this.get_strand().getBeadByType(org.apache.flex.core.IFormatBead), org.apache.flex.core.IFormatBead);
  this._formatter.addEventListener("formatChanged", goog.bind(this.formatReadyHandler, this));
  this.set_text(this._formatter.get_formattedString());
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.FormatableLabelView.prototype.formatReadyHandler = function(event) {
  if (this._formatter) {
    this.set_text(this._formatter.get_formattedString());
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.FormatableLabelView.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'FormatableLabelView', qName: 'org.apache.flex.html.beads.FormatableLabelView'}] };
