/**
 * org.apache.flex.html.beads.FormatableTextInputView
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.FormatableTextInputView');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.html.beads.TextInputWithBorderView');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IFormatBead');
goog.require('org.apache.flex.core.IStrand');



/**
 * @constructor
 * @extends {org.apache.flex.html.beads.TextInputWithBorderView}
 */
org.apache.flex.html.beads.FormatableTextInputView = function() {
  org.apache.flex.html.beads.FormatableTextInputView.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.beads.FormatableTextInputView, org.apache.flex.html.beads.TextInputWithBorderView);


/**
 * @private
 * @type {org.apache.flex.core.IFormatBead}
 */
org.apache.flex.html.beads.FormatableTextInputView.prototype._formatter;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 * @override
 */
org.apache.flex.html.beads.FormatableTextInputView.prototype.set_strand = function(value) {
  org.apache.flex.html.beads.FormatableTextInputView.base(this, 'set_strand', value);
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("beadsAdded", goog.bind(this.handleBeadsAdded, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.FormatableTextInputView.prototype.handleBeadsAdded = function(event) {
  this._formatter = org.apache.flex.utils.Language.as(this.get_strand().getBeadByType(org.apache.flex.core.IFormatBead), org.apache.flex.core.IFormatBead);
  this._formatter.addEventListener("formatChanged", goog.bind(this.formatChangedHandler, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.FormatableTextInputView.prototype.formatChangedHandler = function(event) {
  this.get_textField().set_text(this._formatter.get_formattedString());
  var /** @type {number} */ l = this.get_textField().get_text().length;
  this.get_textField().setSelection(l, l);
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.FormatableTextInputView.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'FormatableTextInputView', qName: 'org.apache.flex.html.beads.FormatableTextInputView'}] };
