/**
 * org.apache.flex.html.beads.controllers.DateChooserMouseController
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.controllers.DateChooserMouseController');

goog.require('org.apache.flex.html.beads.models.DateChooserModel');
goog.require('org.apache.flex.html.beads.DateChooserView');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.html.supportClasses.DateChooserButton');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IBeadView');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IBeadController');
goog.require('org.apache.flex.core.IBeadModel');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBeadController}
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype.set_strand = function(value) {
  this._strand = value;
  var /** @type {org.apache.flex.html.beads.DateChooserView} */ view = org.apache.flex.utils.Language.as(value.getBeadByType(org.apache.flex.core.IBeadView), org.apache.flex.html.beads.DateChooserView);
  view.get_prevMonthButton().addEventListener("click", goog.bind(this.prevMonthClickHandler, this));
  view.get_nextMonthButton().addEventListener("click", goog.bind(this.nextMonthClickHandler, this));
  var /** @type {Array} */ dayButtons = view.get_dayButtons();
  for (var /** @type {number} */ i = 0; i < dayButtons.length; i++) {
    org.apache.flex.utils.Language.as(dayButtons[i], org.apache.flex.events.IEventDispatcher, true).addEventListener("click", goog.bind(this.dayButtonClickHandler, this));
  }
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype.prevMonthClickHandler = function(event) {
  var /** @type {org.apache.flex.html.beads.models.DateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IBeadModel), org.apache.flex.html.beads.models.DateChooserModel);
  var /** @type {number} */ month = model.get_displayedMonth() - 1;
  var /** @type {number} */ year = model.get_displayedYear();
  if (month < 0) {
    month = 11;
    year--;
  }
  model.set_displayedMonth(month);
  model.set_displayedYear(year);
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype.nextMonthClickHandler = function(event) {
  var /** @type {org.apache.flex.html.beads.models.DateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IBeadModel), org.apache.flex.html.beads.models.DateChooserModel);
  var /** @type {number} */ month = model.get_displayedMonth() + 1;
  var /** @type {number} */ year = model.get_displayedYear();
  if (month >= 12) {
    month = 0;
    year++;
  }
  model.set_displayedMonth(month);
  model.set_displayedYear(year);
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype.dayButtonClickHandler = function(event) {
  var /** @type {org.apache.flex.html.supportClasses.DateChooserButton} */ dateButton = org.apache.flex.utils.Language.as(event.get_target(), org.apache.flex.html.supportClasses.DateChooserButton);
  if (dateButton.get_dayOfMonth() > 0) {
    var /** @type {org.apache.flex.html.beads.models.DateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IBeadModel), org.apache.flex.html.beads.models.DateChooserModel);
    var /** @type {Date} */ newDate = new Date(model.get_displayedYear(), model.get_displayedMonth(), dateButton.get_dayOfMonth());
    model.set_selectedDate(newDate);
    org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("change"));
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.controllers.DateChooserMouseController.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateChooserMouseController', qName: 'org.apache.flex.html.beads.controllers.DateChooserMouseController'}], interfaces: [org.apache.flex.core.IBeadController] };
