/**
 * org.apache.flex.html.beads.controllers.DateFieldMouseController
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.controllers.DateFieldMouseController');

goog.require('org.apache.flex.html.beads.DateFieldView');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IDateChooserModel');
goog.require('org.apache.flex.core.IBeadController');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBeadController}
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController.prototype.set_strand = function(value) {
  this._strand = value;
  var /** @type {org.apache.flex.html.beads.DateFieldView} */ viewBead = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.html.beads.DateFieldView), org.apache.flex.html.beads.DateFieldView);
  org.apache.flex.utils.Language.as(viewBead.get_menuButton(), org.apache.flex.events.IEventDispatcher, true).addEventListener("click", goog.bind(this.clickHandler, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController.prototype.clickHandler = function(event) {
  var /** @type {org.apache.flex.html.beads.DateFieldView} */ viewBead = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.html.beads.DateFieldView), org.apache.flex.html.beads.DateFieldView);
  viewBead.set_popUpVisible(true);
  org.apache.flex.utils.Language.as(viewBead.get_popUp(), org.apache.flex.core.UIBase, true).set_x(org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_x() + org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width() - 20);
  org.apache.flex.utils.Language.as(viewBead.get_popUp(), org.apache.flex.core.UIBase, true).set_y(org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_y() + org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_height());
  org.apache.flex.utils.Language.as(viewBead.get_popUp(), org.apache.flex.events.IEventDispatcher, true).addEventListener("change", goog.bind(this.changeHandler, this));
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController.prototype.changeHandler = function(event) {
  var /** @type {org.apache.flex.html.beads.DateFieldView} */ viewBead = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.html.beads.DateFieldView), org.apache.flex.html.beads.DateFieldView);
  var /** @type {org.apache.flex.core.IDateChooserModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IDateChooserModel), org.apache.flex.core.IDateChooserModel);
  model.set_selectedDate(org.apache.flex.utils.Language.as(viewBead.get_popUp().getBeadByType(org.apache.flex.core.IDateChooserModel), org.apache.flex.core.IDateChooserModel, true).get_selectedDate());
  viewBead.set_popUpVisible(false);
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("change"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.controllers.DateFieldMouseController.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateFieldMouseController', qName: 'org.apache.flex.html.beads.controllers.DateFieldMouseController'}], interfaces: [org.apache.flex.core.IBeadController] };
