/**
 * org.apache.flex.html.beads.layouts.DataGridLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.layouts.DataGridLayout');

goog.require('org.apache.flex.html.supportClasses.DataGridColumn');
goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IUIBase');
goog.require('org.apache.flex.core.IBeadLayout');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IDataGridModel');
goog.require('org.apache.flex.core.IDataGridLayout');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBeadLayout}
 * @implements {org.apache.flex.core.IDataGridLayout}
 */
org.apache.flex.html.beads.layouts.DataGridLayout = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.set_strand = function(value) {
  this._strand = value;
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("widthChanged", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("heightChanged", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("childrenAdded", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("itemsCreated", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("elementAdded", goog.bind(this.changeHandler, this));
};


/**
 * @private
 * @type {org.apache.flex.core.UIBase}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype._header;


/**
 * @expose
 * @return {org.apache.flex.core.IUIBase}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.get_header = function() {
  return this._header;
};


/**
 * @expose
 * @param {org.apache.flex.core.IUIBase} value
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.set_header = function(value) {
  this._header = org.apache.flex.utils.Language.as(value, org.apache.flex.core.UIBase, true);
};


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype._columns;


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.get_columns = function() {
  return this._columns;
};


/**
 * @expose
 * @param {Array} value
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.set_columns = function(value) {
  this._columns = value;
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.changeHandler = function(event) {
  var /** @type {number} */ sw = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width();
  var /** @type {number} */ sh = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_height();
  this.get_header().set_x(0);
  this.get_header().set_y(0);
  this.get_header().set_width(sw);
  this.get_header().set_height(25);
  var /** @type {number} */ columnHeight = sh - this.get_header().get_height();
  var /** @type {number} */ columnWidth = sw / this.get_columns().length;
  var /** @type {number} */ xpos = 0;
  var /** @type {number} */ ypos = this.get_header().get_height();
  var /** @type {org.apache.flex.core.IDataGridModel} */ model = org.apache.flex.utils.Language.as(this._strand.getBeadByType(org.apache.flex.core.IDataGridModel), org.apache.flex.core.IDataGridModel);
  for (var /** @type {number} */ i = 0; i < this.get_columns().length; i++) {
    var /** @type {org.apache.flex.core.UIBase} */ column = org.apache.flex.utils.Language.as(this.get_columns()[i], org.apache.flex.core.UIBase);
    column.set_x(xpos);
    column.set_y(ypos);
    column.set_height(columnHeight);
    var /** @type {org.apache.flex.html.supportClasses.DataGridColumn} */ dgc = model.get_columns()[i];
    if (!isNaN(dgc.get_columnWidth()))
      column.set_width(dgc.get_columnWidth());
    else
      column.set_width(columnWidth);
    xpos += column.get_width();
  }
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("layoutComplete"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.layouts.DataGridLayout.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DataGridLayout', qName: 'org.apache.flex.html.beads.layouts.DataGridLayout'}], interfaces: [org.apache.flex.core.IBeadLayout, org.apache.flex.core.IDataGridLayout] };
