/**
 * org.apache.flex.html.beads.layouts.VerticalColumnLayout
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.layouts.VerticalColumnLayout');

goog.require('org.apache.flex.core.UIBase');
goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.IEventDispatcher');
goog.require('org.apache.flex.core.IUIBase');
goog.require('org.apache.flex.core.IMeasurementBead');
goog.require('org.apache.flex.core.IBeadLayout');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IContainer');



/**
 * @constructor
 * @implements {org.apache.flex.core.IBeadLayout}
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout = function() {
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype.set_strand = function(value) {
  this._strand = value;
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("widthChanged", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("heightChanged", goog.bind(this.changeHandler, this));
  org.apache.flex.utils.Language.as(value, org.apache.flex.events.IEventDispatcher, true).addEventListener("childrenAdded", goog.bind(this.changeHandler, this));
};


/**
 * @private
 * @type {number}
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype._numColumns;


/**
 * @expose
 * @return {number}
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype.get_numColumns = function() {
  return this._numColumns;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype.set_numColumns = function(value) {
  this._numColumns = value;
};


/**
 * @private
 * @param {org.apache.flex.events.Event} event
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype.changeHandler = function(event) {
  var /** @type {number} */ sw = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_width();
  var /** @type {number} */ sh = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.UIBase, true).get_height();
  var /** @type {org.apache.flex.core.IUIBase} */ e;
  var /** @type {number} */ i;
  var /** @type {number} */ col = 0;
  var /** @type {Array} */ columns = [];
  for (i = 0; i < this.get_numColumns(); i++)
    columns[i] = 0;
  var /** @type {Array} */ children = org.apache.flex.utils.Language.as(this._strand, org.apache.flex.core.IContainer, true).getChildren();
  var /** @type {number} */ n = children.length;
  for (i = 0; i < n; i++) {
    e = children[i];
    var /** @type {number} */ thisPrefWidth = 0;
    if (org.apache.flex.utils.Language.is(e, org.apache.flex.core.IStrand)) {
      var /** @type {org.apache.flex.core.IMeasurementBead} */ mb = org.apache.flex.utils.Language.as(e.getBeadByType(org.apache.flex.core.IMeasurementBead), org.apache.flex.core.IMeasurementBead);
      if (mb)
        thisPrefWidth = mb.get_measuredWidth();
      else
        thisPrefWidth = e.get_width();
    }
    else
      thisPrefWidth = e.get_width();
    columns[col] = Math.max(columns[col], thisPrefWidth);
    col = (col + 1) % this.get_numColumns();
  }
  var /** @type {number} */ curx = 0;
  var /** @type {number} */ cury = 0;
  var /** @type {number} */ maxHeight = 0;
  col = 0;
  for (i = 0; i < n; i++) {
    e = children[i];
    e.set_x(curx);
    e.set_y(cury);
    curx += columns[col++];
    maxHeight = Math.max(e.get_height(), maxHeight);
    if (col == this.get_numColumns()) {
      cury += maxHeight;
      maxHeight = 0;
      col = 0;
      curx = 0;
    }
  }
  org.apache.flex.utils.Language.as(this._strand, org.apache.flex.events.IEventDispatcher, true).dispatchEvent(new org.apache.flex.events.Event("layoutComplete"));
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.layouts.VerticalColumnLayout.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'VerticalColumnLayout', qName: 'org.apache.flex.html.beads.layouts.VerticalColumnLayout'}], interfaces: [org.apache.flex.core.IBeadLayout] };
