/**
 * org.apache.flex.html.beads.models.DataGridPresentationModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.models.DataGridPresentationModel');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.EventDispatcher');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IDataGridPresentationModel');



/**
 * @constructor
 * @extends {org.apache.flex.events.EventDispatcher}
 * @implements {org.apache.flex.core.IDataGridPresentationModel}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel = function() {
  org.apache.flex.html.beads.models.DataGridPresentationModel.base(this, 'constructor');
};
goog.inherits(org.apache.flex.html.beads.models.DataGridPresentationModel, org.apache.flex.events.EventDispatcher);


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype._columnLabels;


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.get_columnLabels = function() {
  return this._columnLabels;
};


/**
 * @expose
 * @param {Array} value
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.set_columnLabels = function(value) {
  if (value != this._columnLabels) {
    this._columnLabels = value;
    this.dispatchEvent(new org.apache.flex.events.Event("columnsChanged"));
  }
};


/**
 * @private
 * @type {number}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype._rowHeight = 30;


/**
 * @expose
 * @return {number}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.get_rowHeight = function() {
  return this._rowHeight;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.set_rowHeight = function(value) {
  if (value != this._rowHeight) {
    this._rowHeight = value;
    this.dispatchEvent(new org.apache.flex.events.Event("rowHeightChanged"));
  }
};


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.set_strand = function(value) {
  this._strand = value;
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.models.DataGridPresentationModel.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DataGridPresentationModel', qName: 'org.apache.flex.html.beads.models.DataGridPresentationModel'}], interfaces: [org.apache.flex.core.IDataGridPresentationModel] };
