/**
 * org.apache.flex.html.beads.models.DateChooserModel
 *
 * @fileoverview
 *
 * @suppress {checkTypes}
 */

goog.provide('org.apache.flex.html.beads.models.DateChooserModel');

goog.require('org.apache.flex.events.Event');
goog.require('org.apache.flex.events.EventDispatcher');
goog.require('org.apache.flex.core.IStrand');
goog.require('org.apache.flex.core.IDateChooserModel');



/**
 * @constructor
 * @extends {org.apache.flex.events.EventDispatcher}
 * @implements {org.apache.flex.core.IDateChooserModel}
 */
org.apache.flex.html.beads.models.DateChooserModel = function() {
  org.apache.flex.html.beads.models.DateChooserModel.base(this, 'constructor');
  var /** @type {Date} */ today = new Date();
  this.set_displayedYear(today.getFullYear());
  this.set_displayedMonth(today.getMonth());
};
goog.inherits(org.apache.flex.html.beads.models.DateChooserModel, org.apache.flex.events.EventDispatcher);


/**
 * @private
 * @type {org.apache.flex.core.IStrand}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._strand;


/**
 * @expose
 * @param {org.apache.flex.core.IStrand} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_strand = function(value) {
  this._strand = value;
};


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._dayNames = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];


/**
 * @private
 * @type {Array}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._monthNames = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];


/**
 * @private
 * @type {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._displayedYear;


/**
 * @private
 * @type {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._displayedMonth;


/**
 * @private
 * @type {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._firstDayOfWeek = 0;


/**
 * @private
 * @type {Date}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype._selectedDate;


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_dayNames = function() {
  return this._dayNames;
};


/**
 * @expose
 * @param {Array} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_dayNames = function(value) {
  this._dayNames = value;
  this.dispatchEvent(new org.apache.flex.events.Event("dayNamesChanged"));
};


/**
 * @expose
 * @return {Array}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_monthNames = function() {
  return this._monthNames;
};


/**
 * @expose
 * @param {Array} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_monthNames = function(value) {
  this._monthNames = value;
  this.dispatchEvent(new org.apache.flex.events.Event("monthNames"));
};


/**
 * @expose
 * @return {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_displayedYear = function() {
  return this._displayedYear;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_displayedYear = function(value) {
  if (value != this._displayedYear) {
    this._displayedYear = value;
    this.dispatchEvent(new org.apache.flex.events.Event("displayedYearChanged"));
  }
};


/**
 * @expose
 * @return {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_displayedMonth = function() {
  return this._displayedMonth;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_displayedMonth = function(value) {
  if (this._displayedMonth != value) {
    this._displayedMonth = value;
    this.dispatchEvent(new org.apache.flex.events.Event("displayedMonthChanged"));
  }
};


/**
 * @expose
 * @return {number}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_firstDayOfWeek = function() {
  return this._firstDayOfWeek;
};


/**
 * @expose
 * @param {number} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_firstDayOfWeek = function(value) {
  if (value != this._firstDayOfWeek) {
    this._firstDayOfWeek = value;
    this.dispatchEvent(new org.apache.flex.events.Event("firstDayOfWeekChanged"));
  }
};


/**
 * @expose
 * @return {org.apache.flex.html.beads.models.Date}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.get_selectedDate = function() {
  return this._selectedDate;
};


/**
 * @expose
 * @param {Date} value
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.set_selectedDate = function(value) {
  if (value != this._selectedDate) {
    this._selectedDate = value;
    this.dispatchEvent(new org.apache.flex.events.Event("selectedDateChanged"));
    this.set_displayedMonth(value.getMonth());
    this.set_displayedYear(value.getFullYear());
  }
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.flex.html.beads.models.DateChooserModel.prototype.FLEXJS_CLASS_INFO = { names: [{ name: 'DateChooserModel', qName: 'org.apache.flex.html.beads.models.DateChooserModel'}], interfaces: [org.apache.flex.core.IDateChooserModel] };
